image snakePic, item, field;

int freeCells, snakeLenth;

class vec2
{
	int x, y;
	vec2(){x = -1; y = -1;}
	vec2(int a, int b){x = a; y = b;}
}

class _food
{
	vec2 pos;
	array<vec2> freeCell(400);   
	void spawn()
	{
		freeCells = 0;
		bool free;
		for(int i = 0; i < 20; i++)
			for(int j = 0; j < 20; j++)
			{
				free = true;
				for(int k = 0; k < snake.size; k++)
				{
					if(snake.body[k].x == i
					&& snake.body[k].y == j)
					{
						free = false;
						break;
					}
				}
				if(free)
				freeCell[freeCells].x = i;
				freeCell[freeCells++].y = j;
			}
		pos = freeCell[rand()%freeCells];
	}
}

_food food;

class _snake
{
	vec2 oldPos;
	int size;
	array<vec2> body(400);
	int dir;
	double time;
	_snake()
	{
		time = 0;
		size = 2;
		oldPos.x = 10;
		oldPos.y = 12;
		body[0].x = 10;
		body[1].x = 10;
		body[0].y = 10;
		body[1].y = 11;
		dir = 0;
		alive = true;
	}
	
	bool alive;
	
	void addCell()
	{
		body[size++] = oldPos;
	}
	
	void update(bool force)
	{
		if(!alive) return;
		if(!force)
			{if(getTime()-0.5 < time) return;}
		else if(getTime()-0.1 < time) return;
		time = getTime();
		array<array<int>> off = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
		oldPos = body[size-1];
		for(int i = size-1; i >= 0; i--)
		{
			if(i > 0)
			body[i] = body[i-1];
			else
			{
				body[0].x += off[dir][0];
				body[0].y += off[dir][1];
				if(body[0].x < 0) body[0].x = 19;
				else if(body[0].x > 19) body[0].x = 0;
				
				if(body[0].y < 0) body[0].y = 19;
				else if(body[0].y > 19) body[0].y = 0;
				
				for(int i = 1; i < size; i++)
				{
					if(body[i].x == body[0].x
					&& body[i].y == body[0].y)
					{
						alive = false;
						return;
					}
				}
			}
		}
		if(body[0].x == food.pos.x
		&& body[0].y == food.pos.y)
		{
			food.spawn();
			addCell();
		}
	}
}

_snake snake;

void main()
{
	button msg;
	msg.setSize(240, 48);
	msg.setPos(120, 216);
	msg.setLabel("Congratulation!\nYou have died!");
	snakeLenth = 2;
	snakePic.load("data/textures/0.png");
	item.load("data/textures/1.png");
	field.load("data/textures/2.png");
	                                                                              ;
	food.spawn();
	setWindowSize(20*24, 20*24);
	while(true)
	{
		     if(getKey(KEY_LEFT) || getKey(KEY_D)) 
			 {
				if(snake.dir != 2)
				snake.dir = 0;
				snake.update(true);
			 }
		else if(getKey(KEY_DOWN) || getKey(KEY_S))
			 {
				if(snake.dir != 3)
				snake.dir = 1;
				snake.update(true);
				
			 }
		else if(getKey(KEY_RIGHT)|| getKey(KEY_A))
			 {
				if(snake.dir != 0)
				snake.dir = 2;
				snake.update(true);
			 }
		else if(getKey(KEY_UP)   || getKey(KEY_W))
			 {
				if(snake.dir != 1)
				snake.dir = 3;
				snake.update(true);
			 }
		snake.update(false);
		startDraw();
		start2d();
		for(int i = 0; i < 20; i++)
			for(int j = 0; j < 20; j++)
			field.draw(i*24, j*24);
		
		for(int i = 0; i < snake.size; i++)
		{
			snakePic.draw(snake.body[i].x*24, snake.body[i].y*24);
		}
		
		item.draw(food.pos.x*24, food.pos.y*24);
		if(!snake.alive) msg.draw();
		pollEvents();
	}
}